submodule: Use cat instead of echo to avoid DOS line-endings
[git/dscho.git] / t / t5570-git-daemon.sh
bloba3a4e47e1d25379e981373e67124c9efe5c76213
1 #!/bin/sh
3 test_description='test fetching over git protocol'
4 . ./test-lib.sh
6 LIB_GIT_DAEMON_PORT=${LIB_GIT_DAEMON_PORT-5570}
7 . "$TEST_DIRECTORY"/lib-git-daemon.sh
8 start_git_daemon
10 test_expect_success 'setup repository' '
11 echo content >file &&
12 git add file &&
13 git commit -m one
16 test_expect_success 'create git-accessible bare repository' '
17 mkdir "$GIT_DAEMON_DOCUMENT_ROOT_PATH/repo.git" &&
18 (cd "$GIT_DAEMON_DOCUMENT_ROOT_PATH/repo.git" &&
19 git --bare init &&
20 : >git-daemon-export-ok
21 ) &&
22 git remote add public "$GIT_DAEMON_DOCUMENT_ROOT_PATH/repo.git" &&
23 git push public master:master
26 test_expect_success 'clone git repository' '
27 git clone "$GIT_DAEMON_URL/repo.git" clone &&
28 test_cmp file clone/file
31 test_expect_success 'fetch changes via git protocol' '
32 echo content >>file &&
33 git commit -a -m two &&
34 git push public &&
35 (cd clone && git pull) &&
36 test_cmp file clone/file
39 test_expect_failure 'remote detects correct HEAD' '
40 git push public master:other &&
41 (cd clone &&
42 git remote set-head -d origin &&
43 git remote set-head -a origin &&
44 git symbolic-ref refs/remotes/origin/HEAD > output &&
45 echo refs/remotes/origin/master > expect &&
46 test_cmp expect output
50 test_expect_success 'prepare pack objects' '
51 cp -R "$GIT_DAEMON_DOCUMENT_ROOT_PATH"/repo.git "$GIT_DAEMON_DOCUMENT_ROOT_PATH"/repo_pack.git &&
52 (cd "$GIT_DAEMON_DOCUMENT_ROOT_PATH"/repo_pack.git &&
53 git --bare repack -a -d
57 test_expect_success 'fetch notices corrupt pack' '
58 cp -R "$GIT_DAEMON_DOCUMENT_ROOT_PATH"/repo_pack.git "$GIT_DAEMON_DOCUMENT_ROOT_PATH"/repo_bad1.git &&
59 (cd "$GIT_DAEMON_DOCUMENT_ROOT_PATH"/repo_bad1.git &&
60 p=`ls objects/pack/pack-*.pack` &&
61 chmod u+w $p &&
62 printf %0256d 0 | dd of=$p bs=256 count=1 seek=1 conv=notrunc
63 ) &&
64 mkdir repo_bad1.git &&
65 (cd repo_bad1.git &&
66 git --bare init &&
67 test_must_fail git --bare fetch "$GIT_DAEMON_URL/repo_bad1.git" &&
68 test 0 = `ls objects/pack/pack-*.pack | wc -l`
72 test_expect_success 'fetch notices corrupt idx' '
73 cp -R "$GIT_DAEMON_DOCUMENT_ROOT_PATH"/repo_pack.git "$GIT_DAEMON_DOCUMENT_ROOT_PATH"/repo_bad2.git &&
74 (cd "$GIT_DAEMON_DOCUMENT_ROOT_PATH"/repo_bad2.git &&
75 p=`ls objects/pack/pack-*.idx` &&
76 chmod u+w $p &&
77 printf %0256d 0 | dd of=$p bs=256 count=1 seek=1 conv=notrunc
78 ) &&
79 mkdir repo_bad2.git &&
80 (cd repo_bad2.git &&
81 git --bare init &&
82 test_must_fail git --bare fetch "$GIT_DAEMON_URL/repo_bad2.git" &&
83 test 0 = `ls objects/pack | wc -l`
87 test_remote_error()
89 do_export=YesPlease
90 while test $# -gt 0
92 case $1 in
93 -x)
94 shift
95 chmod -x "$GIT_DAEMON_DOCUMENT_ROOT_PATH/repo.git"
97 -n)
98 shift
99 do_export=
102 break
103 esac
104 done
106 msg=$1
107 shift
108 cmd=$1
109 shift
110 repo=$1
111 shift || error "invalid number of arguments"
113 if test -x "$GIT_DAEMON_DOCUMENT_ROOT_PATH/$repo"
114 then
115 if test -n "$do_export"
116 then
117 : >"$GIT_DAEMON_DOCUMENT_ROOT_PATH/$repo/git-daemon-export-ok"
118 else
119 rm -f "$GIT_DAEMON_DOCUMENT_ROOT_PATH/$repo/git-daemon-export-ok"
123 test_must_fail git "$cmd" "$GIT_DAEMON_URL/$repo" "$@" 2>output &&
124 echo "fatal: remote error: $msg: /$repo" >expect &&
125 test_cmp expect output
126 ret=$?
127 chmod +x "$GIT_DAEMON_DOCUMENT_ROOT_PATH/repo.git"
128 (exit $ret)
131 msg="access denied or repository not exported"
132 test_expect_success 'clone non-existent' "test_remote_error '$msg' clone nowhere.git "
133 test_expect_success 'push disabled' "test_remote_error '$msg' push repo.git master"
134 test_expect_success 'read access denied' "test_remote_error -x '$msg' fetch repo.git "
135 test_expect_success 'not exported' "test_remote_error -n '$msg' fetch repo.git "
137 stop_git_daemon
138 start_git_daemon --informative-errors
140 test_expect_success 'clone non-existent' "test_remote_error 'no such repository' clone nowhere.git "
141 test_expect_success 'push disabled' "test_remote_error 'service not enabled' push repo.git master"
142 test_expect_success 'read access denied' "test_remote_error -x 'no such repository' fetch repo.git "
143 test_expect_success 'not exported' "test_remote_error -n 'repository not exported' fetch repo.git "
145 stop_git_daemon
146 test_done